/*                                     ___   ___               */
/*           ▄▄▄       ██▓     ██▓███  |\  \ |\  \             */
/*          ▒████▄    ▓██▒    ▓██░  ██▒\ \  \\_\  \            */
/*          ▒██  ▀█▄  ▒██░    ▓██░ ██▓▒ \ \______  \           */
/*          ░██▄▄▄▄██ ▒██░    ▒██▄█▓▒ ▒  \|_____|\  \          */
/*           ▓█   ▓██▒░██████▒▒██▒ ░  ░         \ \__\         */
/*           ▒▒   ▓▒█░░ ▒░▓  ░▒▓▒░ ░  ░          \|__|         */
/*            ▒   ▒▒ ░░ ░ ▒  ░░▒ ░                             */
/*         F a░a s▒e && ░S░c h░ä f e r  \                      */
/*                ░  ░    ░  ░            S o  2 0 1 9         */



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ INCLUDE ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
#include "warehouse.h"
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ INCLUDE ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



warehouse_t * warehouse;



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ IMPLEMENTATION ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
warehouse_t * warehouse_init(void * args)
{
  size_t  BUFFERLEN = 8;
  size_t numbers_taken = (size_t) args;
  /* init */
  warehouse = malloc(sizeof(warehouse_t));

  warehouse->storage = calloc(BUFFERLEN, sizeof(char) );
  for (size_t i = 0; i < BUFFERLEN; i++) { warehouse->storage[i] = '_'; }
  warehouse->length = BUFFERLEN;
  warehouse->numbers_taken = numbers_taken;
  warehouse->p_index = 0;
  warehouse->c_index = 0;
  pthread_mutex_init(&warehouse->p_index_l, NULL);
  pthread_mutex_init(&warehouse->c_index_l, NULL);
  pthread_mutex_init(&warehouse->amountlock, NULL);


  sem_init(&warehouse->fillCount , 0, 0);          // items produced
  sem_init(&warehouse->emptyCount, 0, BUFFERLEN);  // remaining space

  return warehouse;
}

void removeItemFromBuffer(warehouse_t * warehouse)
{
  sem_wait(&warehouse->fillCount);
  /* remove n items in order */
  pthread_mutex_lock(&warehouse->amountlock);
  for (size_t i = 0; i < warehouse->numbers_taken; i++)
  {
    /* lock index */
    pthread_mutex_lock(&warehouse->c_index_l);
    warehouse->storage[warehouse->c_index] = '_';
    warehouse->c_index = ( warehouse->c_index + 1 ) % warehouse->length;
    pthread_mutex_unlock(&warehouse->c_index_l);
  }
  pthread_mutex_unlock(&warehouse->amountlock);
  sem_post(&warehouse->emptyCount);
}

void putItemIntoBuffer(warehouse_t * warehouse)
{
  sem_wait(&warehouse->emptyCount);
  /* lock index */
  pthread_mutex_lock(&warehouse->p_index_l);
  warehouse->storage[warehouse->p_index] = 'x';
  warehouse->p_index = ( warehouse->p_index + 1 ) % warehouse->length;
  pthread_mutex_unlock(&warehouse->p_index_l);
  sem_post(&warehouse->fillCount);
}
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ IMPLEMENTATION ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/
