/*                                     ___   ___               */
/*           ▄▄▄       ██▓     ██▓███  |\  \ |\  \             */
/*          ▒████▄    ▓██▒    ▓██░  ██▒\ \  \\_\  \            */
/*          ▒██  ▀█▄  ▒██░    ▓██░ ██▓▒ \ \______  \           */
/*          ░██▄▄▄▄██ ▒██░    ▒██▄█▓▒ ▒  \|_____|\  \          */
/*           ▓█   ▓██▒░██████▒▒██▒ ░  ░         \ \__\         */
/*           ▒▒   ▓▒█░░ ▒░▓  ░▒▓▒░ ░  ░          \|__|         */
/*            ▒   ▒▒ ░░ ░ ▒  ░░▒ ░                             */
/*         F a░a s▒e && ░S░c h░ä f e r  \                      */
/*                ░  ░    ░  ░            S o  2 0 1 9         */



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ INCLUDE ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
#include "world.h"
#include "warehouse.h"
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ INCLUDE ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ IMPLEMENTATION ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
int run(parameter * param)
{


  pthread_t producer_threads[param->producer_count];
  pthread_t consumer_threads[param->consumer_count];

  warehouse_t *warehouse = warehouse_init((void *) param->numbers_taken);

  for (size_t i = 0; i < param->producer_count; i++)
  {
    if ( 0 != (pthread_create(&producer_threads[i],
                              NULL,
                              producer,
                              (void*) warehouse)))
    {
      /* abort if not all threads can be created */
      perror("cannot create pthread");
      exit(EXIT_FAILURE);
    }
  }


  for (size_t i = 0; i < param->consumer_count; i++)
  {
    if ( 0 != (pthread_create(&consumer_threads[i],
                              NULL,
                              consumer,
                              (void*) warehouse)))
    {
      /* abort if not all threads can be created */
      perror("cannot create pthread");
      exit(EXIT_FAILURE);
    }
  }

  for (size_t i = 0 ; i < param->producer_count ; i++)
  {
    pthread_join(producer_threads[i], NULL);
  }

  for (size_t i = 0 ; i < param->consumer_count ; i++)
  {
    pthread_join(consumer_threads[i], NULL);
  }

  exit(EXIT_SUCCESS);
}
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ IMPLEMENTATION ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/
