/*                                     ___   ___               */
/*           ▄▄▄       ██▓     ██▓███  |\  \ |\  \             */
/*          ▒████▄    ▓██▒    ▓██░  ██▒\ \  \\_\  \            */
/*          ▒██  ▀█▄  ▒██░    ▓██░ ██▓▒ \ \______  \           */
/*          ░██▄▄▄▄██ ▒██░    ▒██▄█▓▒ ▒  \|_____|\  \          */
/*           ▓█   ▓██▒░██████▒▒██▒ ░  ░         \ \__\         */
/*           ▒▒   ▓▒█░░ ▒░▓  ░▒▓▒░ ░  ░          \|__|         */
/*            ▒   ▒▒ ░░ ░ ▒  ░░▒ ░                             */
/*         F a░a s▒e && ░S░c h░ä f e r  \                      */
/*                ░  ░    ░  ░            S o  2 0 1 9         */



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ INCLUDE ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
#include "simulation.h"
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ INCLUDE ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ MAIN ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
int main(int argc, char *argv[])
{
  int help_is_set = 0;
  parameter param = {.producer_count = 5, .consumer_count = 5,
                              .numbers_taken = 1}; 


  /* parsing commandline arguments */
  int64_t opt;
  while ( -1 != (opt = getopt(argc, argv, "hn:p:c:")) )
  {
    switch (opt) {
      case 'h':
        printhelp(stdout, argv[0]);
        help_is_set = 1;
        break;
      case 'n':
        param.numbers_taken = atoi(optarg);
        break;
      case 'p':
        param.producer_count = atoi(optarg);
        /* if there is no philos or we are in an alternete universe abort */
        break;
      case 'c': /* this serves as a timeout */
        param.consumer_count = atoi(optarg);
        break;
      default: /* .?. */
        printhelp(stderr, argv[0]);
        exit(EXIT_FAILURE);
    }
  }


  /* if no help shall be displayed, start the world */
  if (!help_is_set)
  {
    run(&param);
  }

  exit(EXIT_SUCCESS);
}
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ MAIN ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ HELPER FUNCTIONS ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
void printhelp(FILE * where, char * what)
{
  fprintf(where,
      "Usage: %s [-h] [-p <#producer>] [-c <#consumer>] [-n <#numbers_taken>]\n", what);
}
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ HELPER FUNCTIONS ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/
